'------------------------------------------------------------------
' Gdi3d engine converted by Don (don67geo@yahoo.com)
' Based on c/c++ source code by SkurK/b. (skurk@multinet.no)
' Edited by James Keene
'------------------------------------------------------------------
$APPTYPE GUI: $TYPECHECK ON
RANDOMIZE TIMER

Dim AngleX AS integer, _
    AngleY AS integer, _
    AngleZ AS integer

DEFINT GDiR,Ox,X1,i,j,k,l,m,n,Nx,Ny,hDC,Xx,cDC
DEFINT Tx,Ty,Tz,X,Y,Z,X2,X3,Y1,Y2,Y3,Z1,Z2,Z3

DEFINT NumPoints = 8    ' Number of points in object
DEFINT NumVerts = 12    ' How many connect-lines

DIM Points(NumPoints, 1 To 3) AS integer, _
    Vertices(NumVerts, 1 TO 3) AS integer
DIM Rotation(NumPoints, 1 TO 3) AS integer

DIM Sinus(512) AS integer, _
    CoSin(512) AS integer

' Precalc Sine and CoSinus table, so we don't have to
' deal with realtime floating-points
defsng trig
FOR j = 1 TO 512
    trig=pi*j/256
    Sinus(j) = sin(trig) shl 8  'sin x 256
    CoSin(j) = cos(trig) shl 8  'cos x 256
NEXT j

' Copy DATA lines to our tables..
' Points of object
Points(1, 1) =-72: Points(1, 2) =-72: Points(1, 3) =-72
Points(2, 1) = 72: Points(2, 2) =-72: Points(2, 3) =-72
Points(3, 1) = 72: Points(3, 2) = 72: Points(3, 3) =-72
Points(4, 1) =-72: Points(4, 2) = 72: Points(4, 3) =-72
Points(5, 1) =-72: Points(5, 2) =-72: Points(5, 3) = 72
Points(6, 1) = 72: Points(6, 2) =-72: Points(6, 3) = 72
Points(7, 1) = 72: Points(7, 2) = 72: Points(7, 3) = 72
Points(8, 1) =-72: Points(8, 2) = 72: Points(8, 3) = 72
   
' Connect-Lines data
Vertices( 1, 1)=5: Vertices( 1, 2)=1: Vertices( 1, 3)=8
Vertices( 2, 1)=1: Vertices( 2, 2)=4: Vertices( 2, 3)=8
Vertices( 3, 1)=6: Vertices( 3, 2)=5: Vertices( 3, 3)=7
Vertices( 4, 1)=5: Vertices( 4, 2)=8: Vertices( 4, 3)=7
Vertices( 5, 1)=2: Vertices( 5, 2)=6: Vertices( 5, 3)=3
Vertices( 6, 1)=6: Vertices( 6, 2)=7: Vertices( 6, 3)=3
Vertices( 7, 1)=1: Vertices( 7, 2)=2: Vertices( 7, 3)=4
Vertices( 8, 1)=2: Vertices( 8, 2)=3: Vertices( 8, 3)=4
Vertices( 9, 1)=4: Vertices( 9, 2)=3: Vertices( 9, 3)=8
Vertices(10, 1)=3: Vertices(10, 2)=7: Vertices(10, 3)=8
Vertices(11, 1)=5: Vertices(11, 2)=6: Vertices(11, 3)=1
Vertices(12, 1)=6: Vertices(12, 2)=2: Vertices(12, 3)=1

CREATE my3D AS FORM
  maximizebox = false
  resizeable = false
  caption = "GDi 3D Cube"
  center
  height = 240
  width  = 296
  CREATE c3D AS CANVAS
    top = 0
    left = 0
    height = my3D.clientheight
    width = my3D.clientwidth
    onpaint = paint_bmp
  END CREATE
  onkeydown = exitkey
  CREATE sb As STATUSBAR
  END CREATE
END CREATE

DEFINT fcw = my3D.clientwidth
DEFINT fch = my3D.clientheight-20

DIM bm0 AS Bitmap
bm0.width=fcw: bm0.height=fch: bm0.recreate
bm0.xsize=fcw: bm0.ysize=fch  'for .draw method

DIM bm AS Bitmap
bm.width=fcw: bm.height=fch: bm.recreate
bm.xsize=fcw: bm.ysize=fch  'for .draw method

DIM r0 As RECT
r0.left=0: r0.top=0: r0.right=fcw: r0.bottom=fch

DIM t1 as TIMER
WITH t1
.Repeated=true: .Interval=150: .OnTimer=vector: .Enabled=true
END WITH

my3D.showmodal
END

defint rec
vector:
if rec then return else INC(rec)  'prevent recursion
'-- Rotate angles
INC(AngleX)
IF AngleX > 512 THEN AngleX = 1
INC(AngleY,2)
IF AngleY > 512 THEN AngleY = 1
INC(AngleZ,4)
IF AngleZ > 512 THEN
  AngleZ = 1: sb.text="Proof of intelligent life!"
END IF
IF AngleX = 257 THEN sb.text="We'll crash if we get too close."
IF AngleY = 257 THEN sb.text="Can you land on it?"
IF RND(256)=0 THEN sb.text="This is no astroid, Captain."
IF RND(512)=0 THEN sb.text="My instruments are going crazy."
IF RND(512)=0 THEN sb.text="It has an anti-gravity force field."
IF RND(512)=0 THEN sb.text="I'm the only crew member still alive, Captain."

'-- Now let's rotate the points according to angles
FOR i = 1 TO NumPoints
  X = Points(i, 1): Y = Points(i, 2): Z = Points(i, 3)

  Ty = Y * CoSin(AngleX) - Z  * Sinus(AngleX): Ty = Ty / 256
  Tz = Y * Sinus(AngleX) + Z  * CoSin(AngleX): Tz = Tz / 256
  Tx = X * CoSin(AngleY) - Tz * Sinus(AngleY): Tx = Tx / 256
  Tz = X * Sinus(AngleY) + Tz * CoSin(AngleY): Tz = Tx / 256
  Ox = Tx
  Tx = Tx * CoSin(AngleZ) - Ty * Sinus(AngleZ): Tx = Tx / 256
  Ty = Ox * Sinus(AngleZ) + Ty * CoSin(AngleZ): Ty = Ty / 256
  Nx = 148 + 128 * Tx / (200 - Tz)
  Ny = 100 - 128 * Ty / (200 - Tz)
   
  Rotation(i, 1) = Nx: Rotation(i, 2) = Ny: Rotation(i, 3) = Tz
NEXT i

bm.copyrect r0,bm0,r0  'clear bitmap
doevents
'-- And now, let's check if face N is visible, and if we should draw it.
FOR j = 1 TO NumVerts
  k = Vertices(j, 1): l = Vertices(j, 2): m = Vertices(j, 3)
  X1 = Rotation(k, 1): X2 = Rotation(l, 1): X3 = Rotation(m, 1)
  Y1 = Rotation(k, 2): Y2 = Rotation(l, 2): Y3 = Rotation(m, 2)
  Z1 = Rotation(k, 3): Z2 = Rotation(l, 3): Z3 = Rotation(m, 3)

'  GDiR = (X3 - X1) * (Y2 - Y1) - ((X2 - X1) * (Y3 - Y1))
ASM mov eax,X3: ASM sub eax,X1: ASM mov edx,Y2: ASM sub edx,Y1
ASM imul edx: ASM mov GDiR,eax
ASM mov eax,X2: ASM sub eax,X1: ASM mov edx,Y3: ASM sub edx,Y1
ASM imul edx: ASM sub GDiR,eax

'-- Render the cube
IF GDiR < -256 THEN
  k = j * 10000
  bm.Line X1, Y1, X2, Y2, k
  bm.Line X2, Y2, X3, Y3, k
  bm.Line X3, Y3, X1, Y1, k
  doevents
  '-- Solid filler
  l = (X1 + X2 + X3) / 3
  m = (Y1 + Y2 + Y3) / 3
  push m: push l: i=bm.handle: push i
  ASM call GetPixel
  i=eax
  if i>=0 and i<>k THEN  
    bm.Paint l, m, k, k
    doevents
  END IF
END IF
NEXT j
my3D.Caption = "GDi 3D Cube [X1:" + _
               STR$(X1) +" X2:" + _
               STR$(X2) +" X3:" + _
               STR$(X3) +"]"
c3D.RePaint
rec=0  'allow bm update
return

DEFINT rec1
paint_bmp:
IF rec1 THEN return ELSE INC(rec1)
c3D.copyrect r0,bm,r0
rec1=0
return

exitkey:
IF wParam<>27 THEN goto vector

fclose:
my3D.close
return
